# -*- coding: utf-8 -*-
#
# finDuplicateEmailAddress.py - Print a list of users that have the same 
#                               email address set 
#
# Copyright (c) 2012 MailStore Software GmbH
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

# MailStore Management API connection settings
USER = "admin"
PASSWORD = "admin"
HOST = "localhost"
PORT = 8463

################### DON'T CHANGE ANYTHING BELOW THIS LINE ###################
import mailstoreapi

# Connect to MailStore Management API
api = mailstoreapi.ManagementAPI(USER,  PASSWORD,  HOST,  PORT)

emailUser = {}

# Walk through list of users
users = api.GetUserList()
for user in users:
    user = user["userName"]
    emailAddresses = api.GetUserInfo(user)["emailAddresses"]
    for emailAddress in emailAddresses:
        if emailAddress in emailUser:
            emailUser[emailAddress].append(user)
        else:
            emailUser[emailAddress] = [user]

for emailAddress, users in emailUser.items():
    if len(users) > 1:
        print("{0} Users using email address {1}: {2}".format(len(users), emailAddress, str(users)))
